/* Box.h
 *
 * fishtank - fish swarm simulation
 * by Andreas Textor <a.textor@kantico.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef BOX_H_
#define BOX_H_
#include "Object.h"
#define box new Box

/**
 * Repräsentiert einen Kasten mit bestimmten Dimensionen
 */
class Box : public Object {
private:
	/**
	 * Die Breite des Kastens
	 */
	 
	double width;
	/**
	 * Die Höhe des Kastens
	 */
	 
	double height;
	/**
	 * Die Tiefe des Kastens
	 */
	double depth;
	
public:
	/**
	 * Konstruktor: Liest die notwendigen Dimensionen und optional ein Material.
	 */
	Box(double width, double height, double depth, Material* mat = 0);
	
	/**
	 * Zeichnet das Objekt
	 */
	void draw();
	
	/**
	 * Default-Destruktor
	 */
	virtual ~Box();
};

#endif /*BOX_H_*/
