/* Node.h
 *
 * fishtank - fish swarm simulation
 * by Andreas Textor <a.textor@kantico.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef NODE_H_
#define NODE_H_
#include <cstdlib>
#include <GL/glut.h>

/**
 * Abstrakte Klasse, die einen Knoten im Szenengraphen repräsentiert.
 * Zunächst hat ein Knoten nur einen Kind-Knoten und eine work()-Methode zum
 * Traversieren des Baums.
 */
class Node {
protected:
	/**
	 * Der Kind-Knoten
	 */
	Node* child;

	/**
	 * Default-Konstruktor
	 */
	Node();

	/**
	 * Konstruktor mit einem Kind-Knoten
	 */
	Node(Node* child);

public:
	/**
	 * Abstrakte Methode zum Traversieren des Baumes
	 */
	virtual void work() = 0;

	/**
	 * Default-Destruktor
	 */
	virtual ~Node();
};

#endif /*NODE_H_*/
